#ifndef H8_H_DEFINED
#define H8_H_DEFINED

extern int Main(void);
extern void Buttons_Init(void);
extern void Buttons_Close(void);
extern void lcd_marquee(char *);

#if defined(IR_H_DEFINED)
extern void IR_Init(void);
extern void IR_Close(void);
#endif

#define TRUE	1
#define FALSE	0
#define NUL	'\0'
#define NULL	((void*) 0)

// define datatypes
typedef unsigned char		byte;
typedef unsigned short int	word;
typedef short int		int16;
typedef unsigned short int	unit16;

// bit manipulation
#define bit0	(1 << 0)
#define bit1	(1 << 1)
#define bit2	(1 << 2)
#define bit3	(1 << 3)
#define bit4	(1 << 4)
#define bit5	(1 << 5)
#define bit6	(1 << 6)
#define bit7	(1 << 7)

#define bit_set(byte,bit) asm("bset %0,@%1\n" : : "i" (bit),"r" (byte))
#define bit_store(byte,bit) asm("bst %0,@%1\n" : : "i" (bit),"r" (byte))
#define bit_load(mask,bit) asm("bld %0,%1l\n" : : "i" (bit),"r" (mask):"cc")
#define bit_clear(byte,bit) asm("bclr %0,@%1\n" : : "i" (bit),"r" (byte))

#define SaveRegisters asm("push r0-r5 \n\t")
#define RestoreRegisters asm("pop r5-r0 \n\t")


// exception handling
#define Enable	asm(" andc #0x7f, ccr ")
#define Disable	asm(" orc #0x80, ccr ")
#define Nop	asm(" nop ");

static volatile byte Running;

asm (
    ".section .init\n\t"
    ".global _start\n"
    "_start:\n\t"
    "push r0\n\t"
    "push r1\n\t"
    "push r2\n\t"
    "push r3\n\t"
    "jsr _RCX_Init\n\t"
    "pop r3\n\t"
    "pop r2\n\t"
    "pop r1\n\t"
    "pop r0\n\t"
    "rts\n\t"
    ".string \"Do you byte, when I knock?\""
);

void RCX_Init(void)
{
    char *ldccMarquee = "ldcc 1.0.0 by seibz     ";

    /*ALWAYS have the statements below in startup. If you don't the IR transmit will stay on
    and you WILL burn out your ir light(s). I burnt out a couple and had to solder new ones
    on my RCX before I figured this out. */
    asm (
        "; disable IR on startup \n\t"
        "mov.w #0xffbb, r0 \n\t"
        "bset #7 @r0 \n\t"
        "; setup stack \n\t"
        "mov.w #0xff00, sp \n\t"
    );

    // Scrolling Marqee
    //application name and version
#if defined(seibz)
    lcd_marquee(ldccMarquee);
#endif

    Buttons_Init();

#if defined(IR_H_DEFINED)
    IR_Init();
#endif


    Main();


#if defined(IR_H_DEFINED)
    IR_Close();
#endif

    Buttons_Close();
}

void RCX_Reset(void)
{
    /* Delete the firmware */
    if (Running)
    {
        *(char *)0xffcc = 1;
    }
    else
    {
        *(char *)0xffcc = 0;
    }
    (*(void (**)(void))0)();
    //RCX_Init();
}

#endif
