#include "H8.h"

#ifndef IO_PORTS_H_DEFINED
#define IO_PORTS_H_DEFINED

/*
 * Buttons On/Off, Run.
 */
#define P4DR		*((volatile byte *) 0xffb7)
#define P4DDR		*((volatile byte *) 0xffb5)
#define P4DDR_ROM	*((volatile byte *) 0xfd83)
#define RunButton	! ( P4DR & bit2 )
#define OnOffButton	! ( P4DR & bit1 )

#define P7DR		*((volatile byte *) 0xffbe)
#define PrgmButton	! ( P7DR & bit7 )
#define ViewButton	! ( P7DR & bit6 )

/*
 * Sensor I/O port.
 */
#define P6DR		*((volatile byte *) 0xffbb)
#define P6DDR		*((volatile byte *) 0xffb9)
#define P6DDR_ROM	*((volatile byte *) 0xfd85)
#define TurnOnPort1         P6DR |= bit2
#define TurnOffPort1		P6DR &= ~bit2
#define TurnOnPort2         P6DR |= bit1
#define TurnOffPort2		P6DR &= ~bit1
#define TurnOnPort3         P6DR |= bit0;
#define TurnOffPort3		P6DR &= bit0;

static byte Port1Active = FALSE;
static byte Port2Active = FALSE;
static byte Port3Active = FALSE;



#define OutputPorts *(( volatile byte *) 0xf000 )
#define Amask	0xc0
#define Bmask	0x0c
#define Cmask	0x03

#define Float	0
#define OnPos	1
#define OnNeg	2
#define Brake	3

void OutputPortsFloat(void) {
	OutputPorts = 0;
}

void PortA(byte state) {
	byte temp;

	temp = OutputPorts;
	temp &= ~Amask;
	temp |= (state << 6);
	OutputPorts = temp;
}

void PortB(byte state) {
	byte temp;

	temp = OutputPorts;
	temp &= ~Bmask;
	temp |= (state << 2);
	OutputPorts = temp;
}

void PortC(byte state) {
	byte temp;

	temp = OutputPorts;
	temp &= ~Cmask;
	temp |= (state << 0);
	OutputPorts = temp;
}

#endif
