OUTPUT_FORMAT(srec)
OUTPUT_ARCH(h8300)
ENTRY(_start)
MEMORY
{
	vectors	: ORIGIN = 0x0000, LENGTH = 0xc4
	ram : ORIGIN = 0x0100, LENGTH = 0xfdfc
	topram : ORIGIN = 0xfefc, LENGTH = 0x4
}

SECTIONS
{
	.vectors : {
		_rom_reset_vector = 0x0000;
		*(.vectors)
	} > vectors

	.text 0x8000: {
        *(.init)
		*(.text)
		*(.rodata)
		*(.strings)
	} > ram

	.data : {
		*(.data)
	} > ram

	.bss : {
		__bss_start = . ;
		*(.bss)
		*(COMMON)
		__end = . ;
	} > ram

	.stack : {
		_stack = . ;
		*(.stack)
	} > topram

	/DISCARD/ : {
		*(.vectors)
	}
}
